diff --git a/distrib/utils/sysinst/partman.c b/distrib/utils/sysinst/partman.c
index c1453cd..61248ab 100644
--- a/distrib/utils/sysinst/partman.c
+++ b/distrib/utils/sysinst/partman.c
@@ -32,60 +32,58 @@
 
 /* partman.c - extended partitioning */
 
+#include <fcntl.h>
 #include <errno.h>
+#include <libgen.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <unistd.h>
-#include <fcntl.h>
 #include <util.h>
 
 #include "defs.h"
-#include "md.h"
 #include "msg_defs.h"
 #include "menu_defs.h"
 
+/* XXX: replace all MAX_ defince with depeding on kernel settings vars */
+#define MAX_ENTRIES 96
 
-typedef struct {
-	int retvalue;
-	int dev_num;
-	pm_devs_t *dev_pm;
-	char fullname[SSTRSIZE];
-	enum {PM_DISK_T, PM_PART_T, PM_RAID_T, PM_VND_T, PM_CGD_T} type;
-} part_entry_t;
-
-#define MNTS_MAX 96
-struct {
-    const char *diskdev, *mnt_opts, *fsname;
-    char *pi_mount;
-    int pm_part;
-} mnts[MNTS_MAX];
-
-#define MAX_RAIDS 16 // TODO: replace by true way
+#define MAX_RAID 8
 #define MAX_IN_RAID 48
-struct raids_t {
+typedef struct raids_t {
 	int enabled;
-	pm_devs_t *pm[MAX_IN_RAID];
+	int blocked;
+	int node;
 	char pm_name[MAX_IN_RAID][SSTRSIZE];
 	int pm_part[MAX_IN_RAID];
 	int pm_is_spare[MAX_IN_RAID];
 	int numRow, numCol, numSpare;
-	int sectPerSU, SUsPerParityUnit, SUsPerReconUnit, RAID_level;
-} raids[MAX_RAIDS];
+	int sectPerSU, SUsPerParityUnit, SUsPerReconUnit, raid_level;
+	uint total_size;
+	pm_devs_t *pm[MAX_IN_RAID];
+} raids_t;
+raids_t raids[MAX_RAID];
 
-#define MAX_VNDS 4
-struct vnds_t {
+#define MAX_VND 4
+typedef struct vnds_t {
 	int enabled;
+	int blocked;
+	int node;
 	char filepath[STRSIZE];
 	int size;
 	int readonly;
 	int is_exist;
 	int manual_geom;
 	int secsize, nsectors, ntracks, ncylinders;
-} vnds[MAX_VNDS];
+	int pm_part;    /* Used only for */
+	pm_devs_t *pm;  /* reffering device */
+} vnds_t;
+vnds_t vnds[MAX_VND];
 
-#define MAX_CGDS 4
-struct cgds_t {
+#define MAX_CGD 4
+typedef struct cgds_t {
 	int enabled;
+	int blocked;
+	int node;
 	pm_devs_t *pm;
 	char pm_name[SSTRSIZE];
 	int pm_part;
@@ -94,13 +92,80 @@ struct cgds_t {
 	const char *enc_type;
 	const char *iv_type;
 	int key_size;
-} cgds[MAX_CGDS];
+} cgds_t;
+cgds_t cgds[MAX_CGD];
+
+#define MAX_LVM_VG 16
+#define MAX_LVM_PV 255
+#define MAX_LVM_LV 255
+typedef struct pv_t {
+	pm_devs_t *pm;
+	char pm_name[SSTRSIZE];
+	int pm_part;
+	int metadatasize;
+	int metadatacopies;
+	int labelsector;
+	int setphysicalvolumesize;
+} pv_t;
+typedef struct lv_t {
+	int blocked;
+	int size;
+	char name[SSTRSIZE];
+	int readonly;
+	int contiguous;
+	char extents[SSTRSIZE];
+	int minor;
+	int mirrors;
+	int regionsize;
+	int persistent;
+	int readahead;
+	int stripes;
+	int stripesize;
+	int zero;
+} lv_t;
+typedef struct lvms_t {
+	int enabled;
+	int blocked;
+	char name[SSTRSIZE];
+	int maxlogicalvolumes;
+	int maxphysicalvolumes;
+	int physicalextentsize;
+	uint total_size;
+	pv_t pv[MAX_LVM_PV];
+	lv_t lv[MAX_LVM_LV];
+} lvms_t;
+lvms_t lvms[MAX_LVM_VG];
+
+typedef struct structinfo_t {
+	int max;
+	uint entry_size;
+	uint parent_size;
+	void *entry_first;
+	void *entry_enabled;
+	void *entry_blocked;
+	void *entry_node;
+} structinfo_t;
+structinfo_t raids_t_info, vnds_t_info, cgds_t_info, lvms_t_info, lv_t_info;
+
+typedef struct pm_upddevlist_adv_t {
+	const char *create_msg;
+	int pe_type;
+	structinfo_t *s;
+	int sub_num;
+	struct pm_upddevlist_adv_t *sub;
+} pm_upddevlist_adv_t;
+
+#define MAX_MNTS 48
+struct {
+    char dev[STRSIZE];
+    const char *mnt_opts, *on;
+} mnts[MAX_MNTS];
 
-int manage_newdev;
-int manage_curdev;
-int manage_raid_spare_cur;
+int cursel; /* Number of selected main menu entrie */
+int changed; /* flag indicating that we have unsaved changes */
+int raid_curspare; /* XXX: replace by true way */
 
-enum { /* Raid menu enum */
+enum { /* RAIDframe menu enum */
 	PMR_MENU_DEVS, PMR_MENU_DEVSSPARE, PMR_MENU_RAIDLEVEL, PMR_MENU_NUMROW,
 	PMR_MENU_NUMCOL, PMR_MENU_NUMSPARE,	PMR_MENU_SECTPERSU,	PMR_MENU_SUSPERPARITYUNIT,
 	PMR_MENU_SUSPERRECONUNIT, PMR_MENU_REMOVE, PMR_MENU_END
@@ -117,89 +182,121 @@ enum { /* CGD menu enum */
 	PMC_MENU_KEYGENTYPE, PMC_MENU_VERIFYTYPE, PMC_MENU_REMOVE, PMC_MENU_END
 };
 
-static int partman_manage_edit(int, void (*)(menudesc *, int, void *),
-	int (*)(menudesc *, void *), int (*)(int), void (*)(void *),
-	void *, int, int, int , void *);
-part_entry_t partman_manage_getdev(int);
-static int partman_raid_disk_add(menudesc *, void *);
-static int partman_raid_disk_del(menudesc *, void *);
-static int partman_cgd_disk_set(part_entry_t *);
-static void partman_select(pm_devs_t *);
-static int partman_mountall_sort(const void *, const void *);
-static int partman_mountall(void);
-static int partman_upddevlist(menudesc *, void *);
-static int partman_commit(menudesc *, void *);
-static int partman_submenu(menudesc *, void *);
-static void partman_menufmt(menudesc *, int, void *);
+enum { /* LVM menu enum */
+	PML_MENU_PV, PML_MENU_NAME, PML_MENU_MAXLOGICALVOLUMES,
+	PML_MENU_MAXPHYSICALVOLUMES, PML_MENU_PHYSICALEXTENTSIZE, 
+	PML_MENU_REMOVE, PML_MENU_END
+};
+
+enum { /* LVM submenu (logical volumes) enum */
+	PMLV_MENU_NAME, PMLV_MENU_SIZE, PMLV_MENU_READONLY, PMLV_MENU_CONTIGUOUS,
+	PMLV_MENU_EXTENTS, PMLV_MENU_MINOR, PMLV_MENU_PERSISTENT,
+	PMLV_MENU_MIRRORS, PMLV_MENU_REGIONSIZE, PMLV_MENU_READAHEAD,
+	PMLV_MENU_STRIPES, PMLV_MENU_STRIPESIZE, PMLV_MENU_ZERO, 
+	PMLV_MENU_REMOVE, PMLV_MENU_END
+};
 
+part_entry_t pm_dev_list(int);
+static int pm_raid_disk_add(menudesc *, void *);
+static int pm_raid_disk_del(menudesc *, void *);
+static int pm_cgd_disk_set(cgds_t *, part_entry_t *);
+static int pm_mount(pm_devs_t *, int);
+static int pm_upddevlist(menudesc *, void *);
+static void pm_select(pm_devs_t *);
 
+/* Universal menu for RAID/VND/CGD/LVM entry edit */
 static int
-partman_manage_edit(int menu_entries_count, void (*menu_fmt)(menudesc *, int, void *),
-	int (*action)(menudesc *, void *), int (*check_fun)(int),
-	void (*entry_init)(void *),	void* entry_init_arg,
-	int dev_num, int max, int entry_size, void *entry_enabled)
+pm_edit(int menu_entries_count, void (*menu_fmt)(menudesc *, int, void *),
+	int (*action)(menudesc *, void *), int (*check_fun)(void *),
+	void (*entry_init)(void *, void *),	void *entry_init_arg,
+	void *dev_ptr, int dev_ptr_delta, structinfo_t *s)
 {
-	int i, retvalue = 0, ok = 0;
+	int i, ok = 0;
 
-	if (dev_num < 0) {
+	if (dev_ptr == NULL) {
 		/* We should create new device */
-		for (i = 0; i < max && !ok; i++)
-			if (*(int*)((char*)entry_enabled + entry_size * i) != 1) {
-				manage_curdev = i;
-				entry_init(entry_init_arg);
-				*(int*)((char*)entry_enabled + entry_size * i) = 1;
+		for (i = 0; i < s->max && !ok; i++)
+			if (*(int*)((char*)s->entry_enabled + dev_ptr_delta + s->entry_size * i) == 0) {
+				dev_ptr = (char*)s->entry_first + dev_ptr_delta + s->entry_size * i;
+				entry_init(dev_ptr, entry_init_arg);
 				ok = 1;
 			}
 		if (!ok) {
-			msg_prompt_win("Limit for the devices count was reached!", -1, 18, 0, 0, NULL, NULL, 0);
+			/* We do not have free device slots */
+			process_menu(MENU_ok, deconst(MSG_limitcount));
 			return -1;
 		}
-	} else {
-		/* ... or edit existent */
-		if (*(int*)((char*)entry_enabled + entry_size * dev_num) == 0) {
-			if (logfp)
-				fprintf(logfp, "partman_manage_edit: invalid drive\n");
-				msg_prompt_win("Invalid device!", -1, 18, 0, 0, NULL, NULL, 0);
-			return -2;
-		}
-		manage_curdev = dev_num;
 	}
 
 	menu_ent menu_entries[menu_entries_count];
 	for (i = 0; i < menu_entries_count - 1; i++)
 		menu_entries[i] = (menu_ent) {NULL, OPT_NOMENU, 0, action};
-	menu_entries[i] = (menu_ent) {"REMOVE", OPT_NOMENU, OPT_EXIT, action};
+	menu_entries[i] = (menu_ent) {MSG_fremove, OPT_NOMENU, OPT_EXIT, action};
 
 	int menu_no = -1;
 	menu_no = new_menu(NULL, menu_entries, menu_entries_count,
 		-1, -1, 0, 40, MC_NOCLEAR | MC_SCROLL,
 		NULL, menu_fmt, NULL, NULL, MSG_DONE);
 	
-	process_menu(menu_no, &retvalue);
+	process_menu(menu_no, dev_ptr);
 	free_menu(menu_no);
-	if (check_fun != NULL)
-		check_fun(manage_curdev);
 
-	return retvalue;
+	return check_fun(dev_ptr);
 }
 
-part_entry_t
-partman_manage_getdev(int fstype)
+static void
+pm_getdevstring(char *buf, int len, pm_devs_t *pm_cur, int num)
 {
-	pm_devs_t *pm_i;
-	int dev_num = -1, num_devs;
 	int i;
+
+	if (pm_cur->isspecial)
+		snprintf(buf, len, "%s", pm_cur->diskdev);
+	else if (num + 'a' < 'a' || num + 'a' > 'a' + MAXPARTITIONS)
+		snprintf(buf, len, "%sd", pm_cur->diskdev);
+	else if (pm_cur->gpt) {
+		for (i = 0; i < MAX_WEDGES; i++)
+			if (wedges[i].pm == pm_cur &&
+				wedges[i].ptn == num)
+				snprintf(buf, len, "dk%d", i); // XXX: xxx
+	} else
+		snprintf(buf, len, "%s%c", pm_cur->diskdev, num + 'a');
+
+	return;
+}
+
+/* Show filtered partitions menu */
+part_entry_t
+pm_dev_list(int type)
+{
+	int dev_num = -1, num_devs = 0;
+	int i, ok;
 	int menu_no;
 	menu_ent menu_entries[MAX_DISKS*MAXPARTITIONS];
 	part_entry_t disk_entries[MAX_DISKS*MAXPARTITIONS];
+	pm_devs_t *pm_i;
 
-	for (pm_i = pm_head->next, num_devs = 0; pm_i != NULL; pm_i = pm_i->next)
+	SLIST_FOREACH(pm_i, &pm_head, l)
 		for (i = 0; i < MAXPARTITIONS; i++) {
-			if (pm_i->bsdlabel[i].pi_fstype == fstype) {
-				disk_entries[num_devs].dev_pm = pm_i;
-				disk_entries[num_devs].dev_num = 'a' + i;
-				snprintf(disk_entries[num_devs].fullname, SSTRSIZE, "%s%c",
-						pm_i->diskdev, 'a' + i);
+			ok = 0;
+			switch (type) {
+				case PM_RAID_T:
+					if (pm_i->bsdlabel[i].pi_fstype == FS_RAID)
+						ok = 1;
+					break;
+				case PM_CGD_T:
+					if (pm_i->bsdlabel[i].pi_fstype == FS_CGD)
+						ok = 1;
+					break;
+				case PM_LVM_T:
+					if (pm_i->bsdlabel[i].lvmpv)
+						ok = 1;
+					break;
+			}
+			if (ok && pm_partusage(pm_i, i, 0) == 0) {
+				disk_entries[num_devs].dev_ptr = pm_i;
+				disk_entries[num_devs].dev_num = i;
+				pm_getdevstring(disk_entries[num_devs].fullname, SSTRSIZE, pm_i, i);
+
 				menu_entries[num_devs] = (struct menu_ent) {
 					.opt_name = disk_entries[num_devs].fullname,
 					.opt_action = set_menu_select,
@@ -210,9 +307,9 @@ partman_manage_getdev(int fstype)
 			}
 		}
 
-	menu_no = new_menu("Available disks:",
-		menu_entries, num_devs, -1, -1, (num_devs+1<3)?3:num_devs+1, 13, MC_SCROLL | MC_NOCLEAR,
-		NULL, NULL , NULL, NULL, NULL);
+	menu_no = new_menu(MSG_avdisks,
+		menu_entries, num_devs, -1, -1, (num_devs+1<3)?3:num_devs+1, 13,
+		MC_SCROLL | MC_NOCLEAR, NULL, NULL, NULL, NULL, NULL);
 	if (menu_no == -1)
 		return (part_entry_t) { .retvalue = -1, };
 	process_menu(menu_no, &dev_num);
@@ -225,83 +322,125 @@ partman_manage_getdev(int fstype)
 	return disk_entries[dev_num];
 }
 
-/*** RAIDs ***/
-
-static void
-partman_raid_menufmt(menudesc *m, int opt, void *arg)
+/* Get unused raid*, cgd* or vnd* device */
+static int
+pm_manage_getfreenode(void *node, const char *d, structinfo_t *s)
 {
-	int i, num, ok = 0;
-	
-	num = ((part_entry_t *)arg)[opt].dev_num;
+	int i, ii, ok;
+	char buf[SSTRSIZE];
+	pm_devs_t *pm_i;
 
-	if (raids[num].enabled != 0) {
-		wprintw(m->mw, "   RAID%d - ", raids[num].RAID_level);
-		for (i = 0; i < MAX_IN_RAID; i++)
-			if (raids[num].pm[i] != NULL) {
-				wprintw(m->mw, "%s ", raids[num].pm_name[i]);
-				ok = 1;
+	*(int*)node = -1;
+	for (i = 0; i < s->max; i++) {
+		ok = 1;
+		/* Check that node is not already reserved */
+		for (ii = 0; ii < s->max; ii++)
+			if (*(int*)((char*)s->entry_node + s->entry_size * ii) == i) {
+				ok = 0;
+				break;
 			}
-		if (!ok)
-			wprintw(m->mw, "no components");
+		if (! ok)
+			continue;
+		/* Check that node is not in the device list */
+		snprintf(buf, SSTRSIZE, "%s%d", d, i);
+		SLIST_FOREACH(pm_i, &pm_head, l)
+			if (! strcmp(pm_i->diskdev, buf)) {
+				ok = 0;
+				break;
+			}
+		if (ok) {
+			*(int*)node = i;
+			return i;
+		}
 	}
+	process_menu(MENU_ok, deconst(MSG_nofreedev));
+	return -1;
+}
+
+/***
+RAIDs
+***/
+
+static void
+pm_raid_menufmt(menudesc *m, int opt, void *arg)
+{
+	int i, ok = 0;
+	char buf[STRSIZE]; buf[0] = '\0';
+	raids_t *dev_ptr = ((part_entry_t *)arg)[opt].dev_ptr;
+
+	if (dev_ptr->enabled == 0)
+		return;
+	for (i = 0; i < MAX_IN_RAID; i++)
+		if (dev_ptr->pm[i] != NULL) {
+			strncat(buf, dev_ptr->pm_name[i], STRSIZE);
+			strncat(buf, " ", STRSIZE);
+			ok = 1;
+		}
+	if (ok)
+		wprintw(m->mw, msg_string(MSG_raid_menufmt), dev_ptr->node,
+			dev_ptr->raid_level, buf, dev_ptr->total_size);
+	else
+		wprintw(m->mw, "%s", msg_string(MSG_raid_err_menufmt));
 	return;
 }
 
 static void
-partman_raid_edit_menufmt(menudesc *m, int opt, void *arg)
+pm_raid_edit_menufmt(menudesc *m, int opt, void *arg)
 {
 	int i;
-	char buf[STRSIZE];
-	buf[0] = '\0';
+	char buf[STRSIZE]; buf[0] = '\0';
+	raids_t *dev_ptr = arg;
 
-	switch (opt){
+	switch (opt) {
 		case PMR_MENU_DEVS:
 			for (i = 0; i < MAX_IN_RAID; i++)
-				if (raids[manage_curdev].pm[i] != NULL && raids[manage_curdev].pm_is_spare[i] == 0)
-					snprintf(buf, STRSIZE, "%s %s", buf, raids[manage_curdev].pm_name[i]);
-			wprintw(m->mw, "Disks: %33s", buf);
+				if (dev_ptr->pm[i] != NULL && dev_ptr->pm_is_spare[i] == 0)
+					snprintf(buf, STRSIZE, "%s %s", buf, dev_ptr->pm_name[i]);
+			wprintw(m->mw, msg_string(MSG_raid_disks_fmt), buf);
 			break;
 		case PMR_MENU_DEVSSPARE:
 			for (i = 0; i < MAX_IN_RAID; i++)
-				if (raids[manage_curdev].pm[i] != NULL && raids[manage_curdev].pm_is_spare[i] != 0)
-					snprintf(buf, STRSIZE, "%s %s", buf, raids[manage_curdev].pm_name[i]);
-			wprintw(m->mw, "Spares: %32s", buf);
+				if (dev_ptr->pm[i] != NULL && dev_ptr->pm_is_spare[i] != 0)
+					snprintf(buf, STRSIZE, "%s %s", buf, dev_ptr->pm_name[i]);
+			wprintw(m->mw, msg_string(MSG_raid_spares_fmt), buf);
 			break;
 		case PMR_MENU_RAIDLEVEL:
-			wprintw(m->mw, "RAID level:       %22d", raids[manage_curdev].RAID_level);
+			wprintw(m->mw, msg_string(MSG_raid_level_fmt), dev_ptr->raid_level);
 			break;
 		case PMR_MENU_NUMROW:
-			wprintw(m->mw, "numRow:           %22d", raids[manage_curdev].numRow);
+			wprintw(m->mw, msg_string(MSG_raid_numrow_fmt), dev_ptr->numRow);
 			break;
 		case PMR_MENU_NUMCOL:
-			wprintw(m->mw, "numCol:           %22d", raids[manage_curdev].numCol);
+			wprintw(m->mw, msg_string(MSG_raid_numcol_fmt), dev_ptr->numCol);
 			break;
 		case PMR_MENU_NUMSPARE:
-			wprintw(m->mw, "numSpare:         %22d", raids[manage_curdev].numSpare);
+			wprintw(m->mw, msg_string(MSG_raid_numspare_fmt), dev_ptr->numSpare);
 			break;
 		case PMR_MENU_SECTPERSU:
-			wprintw(m->mw, "sectPerSU:        %22d", raids[manage_curdev].sectPerSU);
+			wprintw(m->mw, msg_string(MSG_raid_sectpersu_fmt), dev_ptr->sectPerSU);
 			break;
 		case PMR_MENU_SUSPERPARITYUNIT:
-			wprintw(m->mw, "SUsPerParityUnit: %22d", raids[manage_curdev].SUsPerParityUnit);
+			wprintw(m->mw, msg_string(MSG_raid_superpar_fmt), dev_ptr->SUsPerParityUnit);
 			break;
 		case PMR_MENU_SUSPERRECONUNIT:
-			wprintw(m->mw, "SUsPerReconUnit:  %22d", raids[manage_curdev].SUsPerReconUnit);
+			wprintw(m->mw, msg_string(MSG_raid_superrec_fmt), dev_ptr->SUsPerReconUnit);
 			break;
 	}
 	return;
 }
 
 static int
-partman_raid_set_value(menudesc *m, void *arg)
+pm_raid_set_value(menudesc *m, void *arg)
 {
-	char buf[SSTRSIZE];
-	const char *msg_to_show = NULL;
 	int retvalue = -1;
 	int *out_var = NULL;
+	char buf[SSTRSIZE];
+	const char *msg_to_show = NULL;
+	raids_t *dev_ptr = arg;
+
 	static menu_ent menuent_disk_adddel[] = {
-	    {"Add", OPT_NOMENU, OPT_EXIT, partman_raid_disk_add}, 
-	    {"Remove", OPT_NOMENU, OPT_EXIT, partman_raid_disk_del}
+	    {MSG_add, OPT_NOMENU, OPT_EXIT, pm_raid_disk_add}, 
+	    {MSG_remove, OPT_NOMENU, OPT_EXIT, pm_raid_disk_del}
 	};
 	static int menu_disk_adddel = -1;
 	if (menu_disk_adddel == -1) {
@@ -311,47 +450,46 @@ partman_raid_set_value(menudesc *m, void *arg)
 	
 	switch (m->cursel) {
 		case PMR_MENU_DEVS:
-			manage_raid_spare_cur = 0;
-			process_menu(menu_disk_adddel, NULL);
+			raid_curspare = 0;
+			process_menu(menu_disk_adddel, dev_ptr);
 			return 0;
 		case PMR_MENU_DEVSSPARE:
-			manage_raid_spare_cur = 1;
-			process_menu(menu_disk_adddel, NULL);
+			raid_curspare = 1;
+			process_menu(menu_disk_adddel, dev_ptr);
 			return 0;
 		case PMR_MENU_RAIDLEVEL:
 			process_menu(MENU_raidlevel, &retvalue);
-			if (retvalue > 0)
-				raids[manage_curdev].RAID_level = retvalue;
+			if (retvalue >= 0)
+				dev_ptr->raid_level = retvalue;
 			return 0;
 		case PMR_MENU_NUMROW:
-			msg_prompt_win("Multi-dimensional arrays are NOT supported!",
-							-1, 18, 0, 0, NULL, NULL, 0);
+			process_menu(MENU_ok, deconst(MSG_raid_nomultidim));
 			return 0;
-			msg_to_show = "numRow?";
-			out_var = &(raids[manage_curdev].numRow);
+			msg_to_show = MSG_raid_numrow_ask;
+			out_var = &(dev_ptr->numRow);
 			break;
 		case PMR_MENU_NUMCOL:
-			msg_to_show = "numCol?";
-			out_var = &(raids[manage_curdev].numCol);
+			msg_to_show = MSG_raid_numcol_ask;
+			out_var = &(dev_ptr->numCol);
 			break;
 		case PMR_MENU_NUMSPARE:
-			msg_to_show = "numSpare?";
-			out_var = &(raids[manage_curdev].numSpare);
+			msg_to_show = MSG_raid_numspare_ask;
+			out_var = &(dev_ptr->numSpare);
 			break;
 		case PMR_MENU_SECTPERSU:
-			msg_to_show = "sectPerSU?";
-			out_var = &(raids[manage_curdev].sectPerSU);
+			msg_to_show = MSG_raid_sectpersu_ask;
+			out_var = &(dev_ptr->sectPerSU);
 			break;
 		case PMR_MENU_SUSPERPARITYUNIT:
-			msg_to_show = "SUsPerParityUnit?";
-			out_var = &(raids[manage_curdev].SUsPerParityUnit);
+			msg_to_show = MSG_raid_superpar_ask;
+			out_var = &(dev_ptr->SUsPerParityUnit);
 			break;
 		case PMR_MENU_SUSPERRECONUNIT:
-			msg_to_show = "SUsPerReconUnit?";
-			out_var = &(raids[manage_curdev].SUsPerReconUnit);
+			msg_to_show = MSG_raid_superrec_ask;
+			out_var = &(dev_ptr->SUsPerReconUnit);
 			break;
 		case PMR_MENU_REMOVE:
-			raids[manage_curdev].enabled = 0;
+			dev_ptr->enabled = 0;
 			return 0;
 	}
 	if (out_var == NULL || msg_to_show == NULL)
@@ -364,11 +502,13 @@ partman_raid_set_value(menudesc *m, void *arg)
 }
 
 static void
-partman_raid_new_init(void* none)
+pm_raid_init(void *arg, void *none)
 {
-	memset(&(raids[manage_curdev]), 0, sizeof raids[manage_curdev]);
-	raids[manage_curdev] = (struct raids_t) {
+	raids_t *dev_ptr = arg;
+	memset(dev_ptr, 0, sizeof(*dev_ptr));
+	*dev_ptr = (struct raids_t) {
 		.enabled = 1,
+		.blocked = 0,
 		.sectPerSU = 32,
 		.SUsPerParityUnit = 1,
 		.SUsPerReconUnit = 1,
@@ -377,59 +517,86 @@ partman_raid_new_init(void* none)
 }
 
 static int
-partman_raid_check(int dev_num)
+pm_raid_check(void *arg)
 {
-	int ok = 0, i;
+	int i, dev_num = 0, min_size = 0, cur_size = 0;
+	raids_t *dev_ptr = arg;
+
+	if (dev_ptr->blocked)
+		return 0;
 	for (i = 0; i < MAX_IN_RAID; i++)
-		if (raids[dev_num].pm[i] != NULL && 
-				raids[dev_num].pm_is_spare[i] != 1) {
-			ok = 1;
-			break;
+		if (dev_ptr->pm[i] != NULL) {
+			cur_size = dev_ptr->pm[i]->bsdlabel[dev_ptr->pm_part[i]].pi_size /
+						(MEG / dev_ptr->pm[i]->sectorsize);
+			if (cur_size < min_size || dev_num == 0)
+				min_size = cur_size;
+			if (!dev_ptr->pm_is_spare[i])
+				dev_num++;
 		}
-	if (! ok)
-		raids[manage_curdev].enabled = 0;
-	return raids[manage_curdev].enabled;
+	/* Calculate summ of available space */
+	if (dev_num > 0) {
+		switch (dev_ptr->raid_level) {
+			case 0:
+				dev_ptr->total_size = min_size * dev_num;
+				break;
+			case 1:
+				dev_ptr->total_size = min_size;
+				break;
+			case 4:
+			case 5:
+				dev_ptr->total_size = min_size * (dev_num - 1);
+				break;
+		}
+		pm_manage_getfreenode(&(dev_ptr->node), "raid", &raids_t_info);
+		if (dev_ptr->node < 0)
+			dev_ptr->enabled = 0;
+	}
+	else
+		dev_ptr->enabled = 0;
+	return dev_ptr->enabled;
 }
 
 static int
-partman_raid_disk_add(menudesc *m, void *arg)
+pm_raid_disk_add(menudesc *m, void *arg)
 {
 	int i;
-	part_entry_t disk_entries = partman_manage_getdev(FS_RAID);
-	if (disk_entries.retvalue < 0)
-		return disk_entries.retvalue;
+	raids_t *dev_ptr = arg;
+	part_entry_t disk_entrie = pm_dev_list(PM_RAID_T);
+	if (disk_entrie.retvalue < 0)
+		return disk_entrie.retvalue;
 
 	for (i = 0; i < MAX_IN_RAID; i++)
-		if (raids[manage_curdev].pm[i] == NULL) {
-			raids[manage_curdev].pm[i] = disk_entries.dev_pm;
-			raids[manage_curdev].pm_part[i] = disk_entries.dev_num;
-			raids[manage_curdev].pm_is_spare[i] = manage_raid_spare_cur;
-			strncpy(raids[manage_curdev].pm_name[i], disk_entries.fullname, SSTRSIZE);
-			if (manage_raid_spare_cur)
-				raids[manage_curdev].numSpare++;
+		if (dev_ptr->pm[i] == NULL) {
+			dev_ptr->pm[i] = disk_entrie.dev_ptr;
+			dev_ptr->pm_part[i] = disk_entrie.dev_num;
+			dev_ptr->pm_is_spare[i] = raid_curspare;
+			strlcpy(dev_ptr->pm_name[i], disk_entrie.fullname, SSTRSIZE);
+			if (raid_curspare)
+				dev_ptr->numSpare++;
 			else
-				raids[manage_curdev].numCol++;
-			raids[manage_curdev].numRow = 1;
+				dev_ptr->numCol++;
+			dev_ptr->numRow = 1;
 			break;
 		}
 	return 0;
 }
 
 static int
-partman_raid_disk_del(menudesc *m, void *arg)
+pm_raid_disk_del(menudesc *m, void *arg)
 {
 	int retvalue = -1, num_devs = 0;
 	int i, pm_cur;
 	int menu_no;
+	raids_t *dev_ptr = arg;
 	menu_ent menu_entries[MAX_IN_RAID];
 	part_entry_t submenu_args[MAX_IN_RAID];
 
 	for (i = 0; i < MAX_IN_RAID; i++) {
-		if (raids[manage_curdev].pm[i] == NULL ||
-			raids[manage_curdev].pm_is_spare[i] != manage_raid_spare_cur)
+		if (dev_ptr->pm[i] == NULL ||
+			dev_ptr->pm_is_spare[i] != raid_curspare)
 			continue;
 		menu_entries[num_devs] = (struct menu_ent) {
-			.opt_name = raids[manage_curdev].pm_name[i],
+			.opt_name = dev_ptr->pm_name[i],
 			.opt_action = set_menu_select,
 			.opt_menu = OPT_NOMENU,
 			.opt_flags = OPT_EXIT,
@@ -438,7 +605,7 @@ partman_raid_disk_del(menudesc *m, void *arg)
 		num_devs++;
 	}
 
-	menu_no = new_menu("Disks in RAID:",
+	menu_no = new_menu(MSG_raid_disks,
 		menu_entries, num_devs, -1, -1, (num_devs+1<3)?3:num_devs+1, 13,
 		MC_SCROLL | MC_NOCLEAR, NULL, NULL, NULL, NULL, NULL);
 	if (menu_no == -1)
@@ -451,46 +618,29 @@ partman_raid_disk_del(menudesc *m, void *arg)
 
 	pm_cur = submenu_args[retvalue].dev_num;
 
-	if (raids[manage_curdev].pm_is_spare[pm_cur])
-		raids[manage_curdev].numSpare--;
+	if (dev_ptr->pm_is_spare[pm_cur])
+		dev_ptr->numSpare--;
 	else
-		raids[manage_curdev].numCol--;
-	raids[manage_curdev].numRow = (raids[manage_curdev].numCol)?1:0;
-	raids[manage_curdev].pm[pm_cur] = NULL;
+		dev_ptr->numCol--;
+	dev_ptr->numRow = (dev_ptr->numCol)?1:0;
+	dev_ptr->pm[pm_cur] = NULL;
 
 	return 0;
 }
 
 static int
-partman_raid_edit(menudesc *m, void *arg)
-{
-	((part_entry_t *)arg)[0].retvalue = m->cursel + 1;
-
-	return partman_manage_edit(PMR_MENU_END, partman_raid_edit_menufmt,
-		partman_raid_set_value,	partman_raid_check, partman_raid_new_init,
-		NULL, ((part_entry_t *)arg)[m->cursel].dev_num, MAX_RAIDS,
-		sizeof raids[0], &(raids[0].enabled));
-}
-
-static int
-partman_raid_commit(void)
+pm_raid_commit(void)
 {
-	int i, ii, raid_devnum;
+	int i, ii;
 	FILE *f;
 	char f_name[STRSIZE];
 
-	for (raid_devnum = 0, i = 0; raid_devnum < MAX_RAIDS && i < MAX_RAIDS;
-			raid_devnum++, i++) {
-		if (! partman_raid_check(i))
+	for (i = 0; i < MAX_RAID; i++) {
+		if (! pm_raid_check(&raids[i]))
 			continue;
 
-		/* Trying to detect free raid device (yes, ugly way) */
-		while (run_program(RUN_SILENT | RUN_ERROR_OK, "raidctl -G raid%d",
-				raid_devnum) == 0)
-			raid_devnum++;
-
 		/* Generating configure file for our raid */
-		snprintf(f_name, SSTRSIZE, "/tmp/raid.%d.conf", raid_devnum);
+		snprintf(f_name, SSTRSIZE, "/tmp/raid.%d.conf", raids[i].node);
 		f = fopen(f_name, "w");
 		if (f == NULL) {
 			endwin();
@@ -517,7 +667,7 @@ partman_raid_commit(void)
 
 		scripting_fprintf(f, "\nSTART layout\n%d %d %d %d\n", raids[i].sectPerSU,
 						raids[i].SUsPerParityUnit, raids[i].SUsPerReconUnit,
-						raids[i].RAID_level);
+						raids[i].raid_level);
 
 		scripting_fprintf(f, "\nSTART queue\nfifo 100\n\n");
 		scripting_fprintf(NULL, "EOF\n");
